##// END OF EJS Templates
Fixed: DEFLOCAL/MINBASE better fix
drtyhlpr -
r89:34f2dfd69efd
parent child
Show More
@@ -1,517 +1,520
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi2-gen-image.sh 2015-2016
4 # rpi2-gen-image.sh 2015-2016
5 #
5 #
6 # Advanced debian "jessie" bootstrap script for RPi2
6 # Advanced debian "jessie" bootstrap script for RPi2
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 10+ github contributors!
15 # Big thanks for patches and enhancements by 10+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Introduce settings
33 # Introduce settings
34 set -e
34 set -e
35 echo -n -e "\n#\n# RPi2 Bootstrap Settings\n#\n"
35 echo -n -e "\n#\n# RPi2 Bootstrap Settings\n#\n"
36 set -x
36 set -x
37
37
38 # Debian release
38 # Debian release
39 RELEASE=${RELEASE:=jessie}
39 RELEASE=${RELEASE:=jessie}
40 KERNEL_ARCH=${KERNEL_ARCH:=arm}
40 KERNEL_ARCH=${KERNEL_ARCH:=arm}
41 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
41 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
42 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
42 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
43 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
43 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
44 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
44 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
45 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
45 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
46 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
46 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
47 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
47 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
48 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
48 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
49
49
50 # Build directories
50 # Build directories
51 BASEDIR="$(pwd)/images/${RELEASE}"
51 BASEDIR="$(pwd)/images/${RELEASE}"
52 BUILDDIR="${BASEDIR}/build"
52 BUILDDIR="${BASEDIR}/build"
53
53
54 # Chroot directories
54 # Chroot directories
55 R="${BUILDDIR}/chroot"
55 R="${BUILDDIR}/chroot"
56 ETCDIR="${R}/etc"
56 ETCDIR="${R}/etc"
57 BOOTDIR="${R}/boot/firmware"
57 BOOTDIR="${R}/boot/firmware"
58 KERNELDIR="${R}/usr/src/linux"
58 KERNELDIR="${R}/usr/src/linux"
59
59
60 # Firmware directory: Blank if download from github
60 # Firmware directory: Blank if download from github
61 FIRMWAREDIR=${FIRMWAREDIR:=""}
61 FIRMWAREDIR=${FIRMWAREDIR:=""}
62
62
63 # General settings
63 # General settings
64 HOSTNAME=${HOSTNAME:=rpi2-${RELEASE}}
64 HOSTNAME=${HOSTNAME:=rpi2-${RELEASE}}
65 PASSWORD=${PASSWORD:=raspberry}
65 PASSWORD=${PASSWORD:=raspberry}
66 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
66 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
67 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
67 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
68 EXPANDROOT=${EXPANDROOT:=true}
68 EXPANDROOT=${EXPANDROOT:=true}
69
69
70 # Keyboard settings
70 # Keyboard settings
71 XKB_MODEL=${XKB_MODEL:=""}
71 XKB_MODEL=${XKB_MODEL:=""}
72 XKB_LAYOUT=${XKB_LAYOUT:=""}
72 XKB_LAYOUT=${XKB_LAYOUT:=""}
73 XKB_VARIANT=${XKB_VARIANT:=""}
73 XKB_VARIANT=${XKB_VARIANT:=""}
74 XKB_OPTIONS=${XKB_OPTIONS:=""}
74 XKB_OPTIONS=${XKB_OPTIONS:=""}
75
75
76 # Network settings (DHCP)
76 # Network settings (DHCP)
77 ENABLE_DHCP=${ENABLE_DHCP:=true}
77 ENABLE_DHCP=${ENABLE_DHCP:=true}
78
78
79 # Network settings (static)
79 # Network settings (static)
80 NET_ADDRESS=${NET_ADDRESS:=""}
80 NET_ADDRESS=${NET_ADDRESS:=""}
81 NET_GATEWAY=${NET_GATEWAY:=""}
81 NET_GATEWAY=${NET_GATEWAY:=""}
82 NET_DNS_1=${NET_DNS_1:=""}
82 NET_DNS_1=${NET_DNS_1:=""}
83 NET_DNS_2=${NET_DNS_2:=""}
83 NET_DNS_2=${NET_DNS_2:=""}
84 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
84 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
85 NET_NTP_1=${NET_NTP_1:=""}
85 NET_NTP_1=${NET_NTP_1:=""}
86 NET_NTP_2=${NET_NTP_2:=""}
86 NET_NTP_2=${NET_NTP_2:=""}
87
87
88 # APT settings
88 # APT settings
89 APT_PROXY=${APT_PROXY:=""}
89 APT_PROXY=${APT_PROXY:=""}
90 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
90 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
91
91
92 # Feature settings
92 # Feature settings
93 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
93 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
94 ENABLE_IPV6=${ENABLE_IPV6:=true}
94 ENABLE_IPV6=${ENABLE_IPV6:=true}
95 ENABLE_SSHD=${ENABLE_SSHD:=true}
95 ENABLE_SSHD=${ENABLE_SSHD:=true}
96 ENABLE_SOUND=${ENABLE_SOUND:=true}
96 ENABLE_SOUND=${ENABLE_SOUND:=true}
97 ENABLE_DBUS=${ENABLE_DBUS:=true}
97 ENABLE_DBUS=${ENABLE_DBUS:=true}
98 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
98 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
99 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
99 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
100 ENABLE_XORG=${ENABLE_XORG:=false}
100 ENABLE_XORG=${ENABLE_XORG:=false}
101 ENABLE_WM=${ENABLE_WM:=""}
101 ENABLE_WM=${ENABLE_WM:=""}
102 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
102 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
103 ENABLE_USER=${ENABLE_USER:=true}
103 ENABLE_USER=${ENABLE_USER:=true}
104 USER_NAME=${USER_NAME:="pi"}
104 USER_NAME=${USER_NAME:="pi"}
105 ENABLE_ROOT=${ENABLE_ROOT:=false}
105 ENABLE_ROOT=${ENABLE_ROOT:=false}
106 ENABLE_ROOT_SSH=${ENABLE_ROOT_SSH:=false}
106 ENABLE_ROOT_SSH=${ENABLE_ROOT_SSH:=false}
107
107
108 # Advanced settings
108 # Advanced settings
109 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
109 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
110 ENABLE_REDUCE=${ENABLE_REDUCE:=flase}
110 ENABLE_REDUCE=${ENABLE_REDUCE:=flase}
111 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
111 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
112 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
112 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
113 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
113 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
114 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
114 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
115 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
115 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
116 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
116 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
117
117
118 # Kernel compilation settings
118 # Kernel compilation settings
119 BUILD_KERNEL=${BUILD_KERNEL:=false}
119 BUILD_KERNEL=${BUILD_KERNEL:=false}
120 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
120 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
121 KERNEL_THREADS=${KERNEL_THREADS:=1}
121 KERNEL_THREADS=${KERNEL_THREADS:=1}
122 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
122 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
123 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
123 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
124 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
124 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
125
125
126 # Kernel compilation from source directory settings
126 # Kernel compilation from source directory settings
127 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
127 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
128 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
128 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
129 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
129 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
130 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
130 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
131
131
132 # Reduce disk usage settings
132 # Reduce disk usage settings
133 REDUCE_APT=${REDUCE_APT:=true}
133 REDUCE_APT=${REDUCE_APT:=true}
134 REDUCE_DOC=${REDUCE_DOC:=true}
134 REDUCE_DOC=${REDUCE_DOC:=true}
135 REDUCE_MAN=${REDUCE_MAN:=true}
135 REDUCE_MAN=${REDUCE_MAN:=true}
136 REDUCE_VIM=${REDUCE_VIM:=false}
136 REDUCE_VIM=${REDUCE_VIM:=false}
137 REDUCE_BASH=${REDUCE_BASH:=false}
137 REDUCE_BASH=${REDUCE_BASH:=false}
138 REDUCE_HWDB=${REDUCE_HWDB:=true}
138 REDUCE_HWDB=${REDUCE_HWDB:=true}
139 REDUCE_SSHD=${REDUCE_SSHD:=true}
139 REDUCE_SSHD=${REDUCE_SSHD:=true}
140 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
140 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
141
141
142 # Encrypted filesystem settings
142 # Encrypted filesystem settings
143 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
143 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
144 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
144 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
145 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
145 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
146 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
146 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
147 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
147 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
148
148
149 # Stop the Crypto Wars
149 # Stop the Crypto Wars
150 DISABLE_FBI=${DISABLE_FBI:=false}
150 DISABLE_FBI=${DISABLE_FBI:=false}
151
151
152 # Chroot scripts directory
152 # Chroot scripts directory
153 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
153 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
154
154
155 # Packages required in the chroot build environment
155 # Packages required in the chroot build environment
156 APT_INCLUDES=${APT_INCLUDES:=""}
156 APT_INCLUDES=${APT_INCLUDES:=""}
157 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo"
157 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo"
158
158
159 # Packages required for bootstrapping
159 # Packages required for bootstrapping
160 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git"
160 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git"
161 MISSING_PACKAGES=""
161 MISSING_PACKAGES=""
162
162
163 set +x
163 set +x
164
164
165 # Add packages required for kernel cross compilation
165 # Add packages required for kernel cross compilation
166 if [ "$BUILD_KERNEL" = true ] ; then
166 if [ "$BUILD_KERNEL" = true ] ; then
167 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
167 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
168 fi
168 fi
169
169
170 # Add libncurses5 to enable kernel menuconfig
170 # Add libncurses5 to enable kernel menuconfig
171 if [ "$KERNEL_MENUCONFIG" = true ] ; then
171 if [ "$KERNEL_MENUCONFIG" = true ] ; then
172 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
172 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
173 fi
173 fi
174
174
175 # Stop the Crypto Wars
175 # Stop the Crypto Wars
176 if [ "$DISABLE_FBI" = true ] ; then
176 if [ "$DISABLE_FBI" = true ] ; then
177 ENABLE_CRYPTFS=true
177 ENABLE_CRYPTFS=true
178 fi
178 fi
179
179
180 # Add cryptsetup package to enable filesystem encryption
180 # Add cryptsetup package to enable filesystem encryption
181 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
181 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
182 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
182 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
183 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
183 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
184
184
185 if [ -z "$CRYPTFS_PASSWORD" ] ; then
185 if [ -z "$CRYPTFS_PASSWORD" ] ; then
186 echo "error: no password defined (CRYPTFS_PASSWORD)!"
186 echo "error: no password defined (CRYPTFS_PASSWORD)!"
187 exit 1
187 exit 1
188 fi
188 fi
189 ENABLE_INITRAMFS=true
189 ENABLE_INITRAMFS=true
190 fi
190 fi
191
191
192 # Add initramfs generation tools
192 # Add initramfs generation tools
193 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
193 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
194 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
194 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
195 fi
195 fi
196
196
197 # Check if all required packages are installed on the build system
197 # Check if all required packages are installed on the build system
198 for package in $REQUIRED_PACKAGES ; do
198 for package in $REQUIRED_PACKAGES ; do
199 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
199 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
200 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
200 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
201 fi
201 fi
202 done
202 done
203
203
204 # Ask if missing packages should get installed right now
204 # Ask if missing packages should get installed right now
205 if [ -n "$MISSING_PACKAGES" ] ; then
205 if [ -n "$MISSING_PACKAGES" ] ; then
206 echo "the following packages needed by this script are not installed:"
206 echo "the following packages needed by this script are not installed:"
207 echo "$MISSING_PACKAGES"
207 echo "$MISSING_PACKAGES"
208
208
209 echo -n "\ndo you want to install the missing packages right now? [y/n] "
209 echo -n "\ndo you want to install the missing packages right now? [y/n] "
210 read confirm
210 read confirm
211 [ "$confirm" != "y" ] && exit 1
211 [ "$confirm" != "y" ] && exit 1
212 fi
212 fi
213
213
214 # Make sure all required packages are installed
214 # Make sure all required packages are installed
215 apt-get -qq -y install ${REQUIRED_PACKAGES}
215 apt-get -qq -y install ${REQUIRED_PACKAGES}
216
216
217 # Check if ./bootstrap.d directory exists
217 # Check if ./bootstrap.d directory exists
218 if [ ! -d "./bootstrap.d/" ] ; then
218 if [ ! -d "./bootstrap.d/" ] ; then
219 echo "error: './bootstrap.d' required directory not found!"
219 echo "error: './bootstrap.d' required directory not found!"
220 exit 1
220 exit 1
221 fi
221 fi
222
222
223 # Check if ./files directory exists
223 # Check if ./files directory exists
224 if [ ! -d "./files/" ] ; then
224 if [ ! -d "./files/" ] ; then
225 echo "error: './files' required directory not found!"
225 echo "error: './files' required directory not found!"
226 exit 1
226 exit 1
227 fi
227 fi
228
228
229 # Check if specified KERNELSRC_DIR directory exists
229 # Check if specified KERNELSRC_DIR directory exists
230 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
230 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
231 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
231 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
232 exit 1
232 exit 1
233 fi
233 fi
234
234
235 # Check if specified CHROOT_SCRIPTS directory exists
235 # Check if specified CHROOT_SCRIPTS directory exists
236 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
236 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
237 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
237 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
238 exit 1
238 exit 1
239 fi
239 fi
240
240
241 # Check if specified device mapping already exists (will be used by cryptsetup)
241 # Check if specified device mapping already exists (will be used by cryptsetup)
242 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
242 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
243 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
243 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
244 exit 1
244 exit 1
245 fi
245 fi
246
246
247 # Don't clobber an old build
247 # Don't clobber an old build
248 if [ -e "$BUILDDIR" ] ; then
248 if [ -e "$BUILDDIR" ] ; then
249 echo "error: directory ${BUILDDIR} already exists, not proceeding"
249 echo "error: directory ${BUILDDIR} already exists, not proceeding"
250 exit 1
250 exit 1
251 fi
251 fi
252
252
253 # Setup chroot directory
253 # Setup chroot directory
254 mkdir -p "${R}"
254 mkdir -p "${R}"
255
255
256 # Check if build directory has enough of free disk space >512MB
256 # Check if build directory has enough of free disk space >512MB
257 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
257 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
258 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
258 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
259 exit 1
259 exit 1
260 fi
260 fi
261
261
262 set -x
262 set -x
263
263
264 # Call "cleanup" function on various signals and errors
264 # Call "cleanup" function on various signals and errors
265 trap cleanup 0 1 2 3 6
265 trap cleanup 0 1 2 3 6
266
266
267 # Add required packages for the minbase installation
267 # Add required packages for the minbase installation
268 if [ "$ENABLE_MINBASE" = true ] && [ "$DEFLOCAL" == "en_US.UTF-8" ] ; then
268 if [ "$ENABLE_MINBASE" = true ] ; then
269 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
269 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
270 else
270 fi
271
272 # Add required locales packages
273 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
271 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
274 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
272 fi
275 fi
273
276
274 # Add parted package, required to get partprobe utility
277 # Add parted package, required to get partprobe utility
275 if [ "$EXPANDROOT" = true ] ; then
278 if [ "$EXPANDROOT" = true ] ; then
276 APT_INCLUDES="${APT_INCLUDES},parted"
279 APT_INCLUDES="${APT_INCLUDES},parted"
277 fi
280 fi
278
281
279 # Add dbus package, recommended if using systemd
282 # Add dbus package, recommended if using systemd
280 if [ "$ENABLE_DBUS" = true ] ; then
283 if [ "$ENABLE_DBUS" = true ] ; then
281 APT_INCLUDES="${APT_INCLUDES},dbus"
284 APT_INCLUDES="${APT_INCLUDES},dbus"
282 fi
285 fi
283
286
284 # Add iptables IPv4/IPv6 package
287 # Add iptables IPv4/IPv6 package
285 if [ "$ENABLE_IPTABLES" = true ] ; then
288 if [ "$ENABLE_IPTABLES" = true ] ; then
286 APT_INCLUDES="${APT_INCLUDES},iptables"
289 APT_INCLUDES="${APT_INCLUDES},iptables"
287 fi
290 fi
288
291
289 # Add openssh server package
292 # Add openssh server package
290 if [ "$ENABLE_SSHD" = true ] ; then
293 if [ "$ENABLE_SSHD" = true ] ; then
291 APT_INCLUDES="${APT_INCLUDES},openssh-server"
294 APT_INCLUDES="${APT_INCLUDES},openssh-server"
292 fi
295 fi
293
296
294 # Add alsa-utils package
297 # Add alsa-utils package
295 if [ "$ENABLE_SOUND" = true ] ; then
298 if [ "$ENABLE_SOUND" = true ] ; then
296 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
299 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
297 fi
300 fi
298
301
299 # Add rng-tools package
302 # Add rng-tools package
300 if [ "$ENABLE_HWRANDOM" = true ] ; then
303 if [ "$ENABLE_HWRANDOM" = true ] ; then
301 APT_INCLUDES="${APT_INCLUDES},rng-tools"
304 APT_INCLUDES="${APT_INCLUDES},rng-tools"
302 fi
305 fi
303
306
304 # Add fbturbo video driver
307 # Add fbturbo video driver
305 if [ "$ENABLE_FBTURBO" = true ] ; then
308 if [ "$ENABLE_FBTURBO" = true ] ; then
306 # Enable xorg package dependencies
309 # Enable xorg package dependencies
307 ENABLE_XORG=true
310 ENABLE_XORG=true
308 fi
311 fi
309
312
310 # Add user defined window manager package
313 # Add user defined window manager package
311 if [ -n "$ENABLE_WM" ] ; then
314 if [ -n "$ENABLE_WM" ] ; then
312 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
315 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
313
316
314 # Enable xorg package dependencies
317 # Enable xorg package dependencies
315 ENABLE_XORG=true
318 ENABLE_XORG=true
316 fi
319 fi
317
320
318 # Add xorg package
321 # Add xorg package
319 if [ "$ENABLE_XORG" = true ] ; then
322 if [ "$ENABLE_XORG" = true ] ; then
320 APT_INCLUDES="${APT_INCLUDES},xorg"
323 APT_INCLUDES="${APT_INCLUDES},xorg"
321 fi
324 fi
322
325
323 # Replace selected packages with smaller clones
326 # Replace selected packages with smaller clones
324 if [ "$ENABLE_REDUCE" = true ] ; then
327 if [ "$ENABLE_REDUCE" = true ] ; then
325 # Add levee package instead of vim-tiny
328 # Add levee package instead of vim-tiny
326 if [ "$REDUCE_VIM" = true ] ; then
329 if [ "$REDUCE_VIM" = true ] ; then
327 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
330 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
328 fi
331 fi
329
332
330 # Add dropbear package instead of openssh-server
333 # Add dropbear package instead of openssh-server
331 if [ "$REDUCE_SSHD" = true ] ; then
334 if [ "$REDUCE_SSHD" = true ] ; then
332 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
335 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
333 fi
336 fi
334 fi
337 fi
335
338
336 # Configure kernel sources if no KERNELSRC_DIR
339 # Configure kernel sources if no KERNELSRC_DIR
337 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
340 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
338 KERNELSRC_CONFIG=true
341 KERNELSRC_CONFIG=true
339 fi
342 fi
340
343
341 # Configure reduced kernel
344 # Configure reduced kernel
342 if [ "$KERNEL_REDUCE" = true ] ; then
345 if [ "$KERNEL_REDUCE" = true ] ; then
343 KERNELSRC_CONFIG=false
346 KERNELSRC_CONFIG=false
344 fi
347 fi
345
348
346 # Execute bootstrap scripts
349 # Execute bootstrap scripts
347 for SCRIPT in bootstrap.d/*.sh; do
350 for SCRIPT in bootstrap.d/*.sh; do
348 head -n 3 "$SCRIPT"
351 head -n 3 "$SCRIPT"
349 . "$SCRIPT"
352 . "$SCRIPT"
350 done
353 done
351
354
352 ## Execute custom bootstrap scripts
355 ## Execute custom bootstrap scripts
353 if [ -d "custom.d" ] ; then
356 if [ -d "custom.d" ] ; then
354 for SCRIPT in custom.d/*.sh; do
357 for SCRIPT in custom.d/*.sh; do
355 . "$SCRIPT"
358 . "$SCRIPT"
356 done
359 done
357 fi
360 fi
358
361
359 # Execute custom scripts inside the chroot
362 # Execute custom scripts inside the chroot
360 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
363 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
361 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
364 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
362 chroot_exec /bin/bash -x <<'EOF'
365 chroot_exec /bin/bash -x <<'EOF'
363 for SCRIPT in /chroot_scripts/* ; do
366 for SCRIPT in /chroot_scripts/* ; do
364 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
367 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
365 $SCRIPT
368 $SCRIPT
366 fi
369 fi
367 done
370 done
368 EOF
371 EOF
369 rm -rf "${R}/chroot_scripts"
372 rm -rf "${R}/chroot_scripts"
370 fi
373 fi
371
374
372 # Remove apt-utils
375 # Remove apt-utils
373 chroot_exec apt-get purge -qq -y --force-yes apt-utils
376 chroot_exec apt-get purge -qq -y --force-yes apt-utils
374
377
375 # Generate required machine-id
378 # Generate required machine-id
376 MACHINE_ID=$(dbus-uuidgen)
379 MACHINE_ID=$(dbus-uuidgen)
377 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
380 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
378 echo -n "${MACHINE_ID}" > "${ETCDIR}/machine-id"
381 echo -n "${MACHINE_ID}" > "${ETCDIR}/machine-id"
379
382
380 # APT Cleanup
383 # APT Cleanup
381 chroot_exec apt-get -y clean
384 chroot_exec apt-get -y clean
382 chroot_exec apt-get -y autoclean
385 chroot_exec apt-get -y autoclean
383 chroot_exec apt-get -y autoremove
386 chroot_exec apt-get -y autoremove
384
387
385 # Unmount mounted filesystems
388 # Unmount mounted filesystems
386 umount -l "${R}/proc"
389 umount -l "${R}/proc"
387 umount -l "${R}/sys"
390 umount -l "${R}/sys"
388
391
389 # Clean up directories
392 # Clean up directories
390 rm -rf "${R}/run/*"
393 rm -rf "${R}/run/*"
391 rm -rf "${R}/tmp/*"
394 rm -rf "${R}/tmp/*"
392
395
393 # Clean up files
396 # Clean up files
394 rm -f "${ETCDIR}/ssh/ssh_host_*"
397 rm -f "${ETCDIR}/ssh/ssh_host_*"
395 rm -f "${ETCDIR}/dropbear/dropbear_*"
398 rm -f "${ETCDIR}/dropbear/dropbear_*"
396 rm -f "${ETCDIR}/apt/sources.list.save"
399 rm -f "${ETCDIR}/apt/sources.list.save"
397 rm -f "${ETCDIR}/resolvconf/resolv.conf.d/original"
400 rm -f "${ETCDIR}/resolvconf/resolv.conf.d/original"
398 rm -f "${ETCDIR}/*-"
401 rm -f "${ETCDIR}/*-"
399 rm -f "${ETCDIR}/apt/apt.conf.d/10proxy"
402 rm -f "${ETCDIR}/apt/apt.conf.d/10proxy"
400 rm -f "${ETCDIR}/resolv.conf"
403 rm -f "${ETCDIR}/resolv.conf"
401 rm -f "${R}/root/.bash_history"
404 rm -f "${R}/root/.bash_history"
402 rm -f "${R}/var/lib/urandom/random-seed"
405 rm -f "${R}/var/lib/urandom/random-seed"
403 rm -f "${R}/initrd.img"
406 rm -f "${R}/initrd.img"
404 rm -f "${R}/vmlinuz"
407 rm -f "${R}/vmlinuz"
405 rm -f "${R}${QEMU_BINARY}"
408 rm -f "${R}${QEMU_BINARY}"
406
409
407 # Calculate size of the chroot directory in KB
410 # Calculate size of the chroot directory in KB
408 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
411 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
409
412
410 # Calculate the amount of needed 512 Byte sectors
413 # Calculate the amount of needed 512 Byte sectors
411 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
414 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
412 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
415 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
413 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
416 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
414
417
415 # The root partition is EXT4
418 # The root partition is EXT4
416 # This means more space than the actual used space of the chroot is used.
419 # This means more space than the actual used space of the chroot is used.
417 # As overhead for journaling and reserved blocks 20% are added.
420 # As overhead for journaling and reserved blocks 20% are added.
418 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 20) \* 1024 \/ 512)
421 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 20) \* 1024 \/ 512)
419
422
420 # Calculate required image size in 512 Byte sectors
423 # Calculate required image size in 512 Byte sectors
421 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
424 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
422
425
423 # Prepare date string for image file name
426 # Prepare date string for image file name
424 DATE="$(date +%Y-%m-%d)"
427 DATE="$(date +%Y-%m-%d)"
425
428
426 # Prepare image file
429 # Prepare image file
427 if [ "$ENABLE_SPLITFS" = true ] ; then
430 if [ "$ENABLE_SPLITFS" = true ] ; then
428 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" bs=512 count=${TABLE_SECTORS}
431 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" bs=512 count=${TABLE_SECTORS}
429 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
432 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
430 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-root.img" bs=512 count=${TABLE_SECTORS}
433 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-root.img" bs=512 count=${TABLE_SECTORS}
431 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
434 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
432
435
433 # Write firmware/boot partition tables
436 # Write firmware/boot partition tables
434 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" 2> /dev/null <<EOM
437 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" 2> /dev/null <<EOM
435 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
438 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
436 EOM
439 EOM
437
440
438 # Write root partition table
441 # Write root partition table
439 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}-root.img" 2> /dev/null <<EOM
442 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}-root.img" 2> /dev/null <<EOM
440 ${TABLE_SECTORS},${ROOT_SECTORS},83
443 ${TABLE_SECTORS},${ROOT_SECTORS},83
441 EOM
444 EOM
442
445
443 # Setup temporary loop devices
446 # Setup temporary loop devices
444 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-debian-${RELEASE}-frmw.img)"
447 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-debian-${RELEASE}-frmw.img)"
445 ROOT_LOOP="$(losetup -o 1M -f --show $BASEDIR/${DATE}-debian-${RELEASE}-root.img)"
448 ROOT_LOOP="$(losetup -o 1M -f --show $BASEDIR/${DATE}-debian-${RELEASE}-root.img)"
446 else # ENABLE_SPLITFS=false
449 else # ENABLE_SPLITFS=false
447 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}.img" bs=512 count=${TABLE_SECTORS}
450 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}.img" bs=512 count=${TABLE_SECTORS}
448 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}.img" bs=512 count=0 seek=${IMAGE_SECTORS}
451 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}.img" bs=512 count=0 seek=${IMAGE_SECTORS}
449
452
450 # Write partition table
453 # Write partition table
451 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}.img" 2> /dev/null <<EOM
454 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}.img" 2> /dev/null <<EOM
452 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
455 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
453 ${ROOT_OFFSET},${ROOT_SECTORS},83
456 ${ROOT_OFFSET},${ROOT_SECTORS},83
454 EOM
457 EOM
455
458
456 # Setup temporary loop devices
459 # Setup temporary loop devices
457 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-debian-${RELEASE}.img)"
460 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-debian-${RELEASE}.img)"
458 ROOT_LOOP="$(losetup -o 65M -f --show $BASEDIR/${DATE}-debian-${RELEASE}.img)"
461 ROOT_LOOP="$(losetup -o 65M -f --show $BASEDIR/${DATE}-debian-${RELEASE}.img)"
459 fi
462 fi
460
463
461 if [ "$ENABLE_CRYPTFS" = true ] ; then
464 if [ "$ENABLE_CRYPTFS" = true ] ; then
462 # Create dummy ext4 fs
465 # Create dummy ext4 fs
463 mkfs.ext4 "$ROOT_LOOP"
466 mkfs.ext4 "$ROOT_LOOP"
464
467
465 # Setup password keyfile
468 # Setup password keyfile
466 echo -n ${CRYPTFS_PASSWORD} > .password
469 echo -n ${CRYPTFS_PASSWORD} > .password
467 chmod 600 .password
470 chmod 600 .password
468
471
469 # Initialize encrypted partition
472 # Initialize encrypted partition
470 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
473 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
471
474
472 # Open encrypted partition and setup mapping
475 # Open encrypted partition and setup mapping
473 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
476 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
474
477
475 # Secure delete password keyfile
478 # Secure delete password keyfile
476 shred -zu .password
479 shred -zu .password
477
480
478 # Update temporary loop device
481 # Update temporary loop device
479 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
482 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
480
483
481 # Wipe encrypted partition (encryption cipher is used for randomness)
484 # Wipe encrypted partition (encryption cipher is used for randomness)
482 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
485 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
483 fi
486 fi
484
487
485 # Build filesystems
488 # Build filesystems
486 mkfs.vfat "$FRMW_LOOP"
489 mkfs.vfat "$FRMW_LOOP"
487 mkfs.ext4 "$ROOT_LOOP"
490 mkfs.ext4 "$ROOT_LOOP"
488
491
489 # Mount the temporary loop devices
492 # Mount the temporary loop devices
490 mkdir -p "$BUILDDIR/mount"
493 mkdir -p "$BUILDDIR/mount"
491 mount "$ROOT_LOOP" "$BUILDDIR/mount"
494 mount "$ROOT_LOOP" "$BUILDDIR/mount"
492
495
493 mkdir -p "$BUILDDIR/mount/boot/firmware"
496 mkdir -p "$BUILDDIR/mount/boot/firmware"
494 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
497 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
495
498
496 # Copy all files from the chroot to the loop device mount point directory
499 # Copy all files from the chroot to the loop device mount point directory
497 rsync -a "${R}/" "$BUILDDIR/mount/"
500 rsync -a "${R}/" "$BUILDDIR/mount/"
498
501
499 # Unmount all temporary loop devices and mount points
502 # Unmount all temporary loop devices and mount points
500 cleanup
503 cleanup
501
504
502 # Create block map file(s) of image(s)
505 # Create block map file(s) of image(s)
503 if [ "$ENABLE_SPLITFS" = true ] ; then
506 if [ "$ENABLE_SPLITFS" = true ] ; then
504 # Create block map files for "bmaptool"
507 # Create block map files for "bmaptool"
505 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img"
508 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img"
506 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}-root.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}-root.img"
509 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}-root.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}-root.img"
507
510
508 # Image was successfully created
511 # Image was successfully created
509 echo "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
512 echo "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
510 echo "$BASEDIR/${DATE}-debian-${RELEASE}-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
513 echo "$BASEDIR/${DATE}-debian-${RELEASE}-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
511 else
514 else
512 # Create block map file for "bmaptool"
515 # Create block map file for "bmaptool"
513 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}.img"
516 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}.img"
514
517
515 # Image was successfully created
518 # Image was successfully created
516 echo "$BASEDIR/${DATE}-debian-${RELEASE}.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
519 echo "$BASEDIR/${DATE}-debian-${RELEASE}.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
517 fi
520 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant